// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by a MIT-style license
// that can be found in the LICENSE file.

part of omnibuild;

/// Mustache template for omnibuild code. Code can be generated directly from
/// OmnibuildSpecFile getters.
const omnibuildTemplateSource = '''
{{{ commentedCopyright }}}

// THIS FILE IS AUTO-GENERATED, PLEASE DO NOT MODIFY BY HAND.

part of {{ library }};

{{{ commentedDescription }}}

{{# messages }}
{{{ commentedDocumentation }}}class {{ name }} extends {{{ superClass }}} {
  /// omnibusId
  static const id = '{{{ omnibusId }}}';

  {{# properties }}
{{{ commentedDocumentation }}}  final {{{ type }}} {{ name }};

  {{/ properties }}
  /// Constructor
  {{ name }}({{{ argumentsString }}})
      : {{# properties }}{{ name }} = {{ name }},{{/ properties }}
        {{ superConstructor }}(id, {{{ dataMap }}});

  /// Internal constructor for fromJson
  {{ name }}._from(final Map<String, dynamic> data{{# properties }},{{{ type }}} {{{ name }}}{{/ properties }})
      : {{# properties }}{{ name }} = {{ name }},{{/ properties }}
        {{ superConstructor }}(id, data);

  /// Data map input constructor
  factory {{ name }}.fromJson(final Map<String, dynamic> data) {
    {{# properties }}
    {{{ type }}} {{ name }};
    {{/ properties }}
    {{# properties }}

    if (data.containsKey('{{ name }}') && data['{{ name }}'] is {{{ jsonType }}}) {
      {{ name }} = {{{ reverseConstruction }}};
    } else {
      throw new ArgumentError.value(
          data, 'data', "No valid field for property '{{ name }}'");
    }
    {{/ properties }}

    return new {{ name }}._from(data{{# properties }},{{{ name }}}{{/ properties }});
  }
}
{{/ messages }}
''';

var _omnibuildTemplate = new Template(omnibuildTemplateSource);
