// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by a MIT-style license
// that can be found in the LICENSE file.

// THIS FILE IS AUTO-GENERATED, PLEASE DO NOT MODIFY BY HAND.

part of omnibuild.test.test_messages;

class DfltStrings extends OmnibusEvent {
  /// omnibusId
  static const id = 'omnibuild.v0.DfltStrings';

  final String simpleString;

  final String stringWithSingleQuotes;

  final String singleLineStringMixedQuotes;

  final String stringLiteralSimple;

  final String stringLiteralWithTripleSingleQuote;

  /// Constructor
  DfltStrings(
      [final String simpleString = 'Hello World!',
      final String stringWithSingleQuotes = "Foo's bar",
      final String singleLineStringMixedQuotes =
          'Herman\'s car reads: "Hello world!"',
      final String stringLiteralSimple = '''Hi there,
This is a multiline message.
''',
      final String stringLiteralWithTripleSingleQuote = '''Hi there,
In Dart literal strings look like this:
\'\'\'Herman\'s car reads: "Hello world!"\'\'\'
'''])
      : simpleString = simpleString,
        stringWithSingleQuotes = stringWithSingleQuotes,
        singleLineStringMixedQuotes = singleLineStringMixedQuotes,
        stringLiteralSimple = stringLiteralSimple,
        stringLiteralWithTripleSingleQuote = stringLiteralWithTripleSingleQuote,
        super.unchecked(id, {
          'simpleString': simpleString,
          'stringWithSingleQuotes': stringWithSingleQuotes,
          'singleLineStringMixedQuotes': singleLineStringMixedQuotes,
          'stringLiteralSimple': stringLiteralSimple,
          'stringLiteralWithTripleSingleQuote':
              stringLiteralWithTripleSingleQuote
        });

  /// Internal constructor for fromJson
  DfltStrings._from(
      final Map<String, dynamic> data,
      String simpleString,
      String stringWithSingleQuotes,
      String singleLineStringMixedQuotes,
      String stringLiteralSimple,
      String stringLiteralWithTripleSingleQuote)
      : simpleString = simpleString,
        stringWithSingleQuotes = stringWithSingleQuotes,
        singleLineStringMixedQuotes = singleLineStringMixedQuotes,
        stringLiteralSimple = stringLiteralSimple,
        stringLiteralWithTripleSingleQuote = stringLiteralWithTripleSingleQuote,
        super.unchecked(id, data);

  /// Data map input constructor
  factory DfltStrings.fromJson(final Map<String, dynamic> data) {
    String simpleString;
    String stringWithSingleQuotes;
    String singleLineStringMixedQuotes;
    String stringLiteralSimple;
    String stringLiteralWithTripleSingleQuote;

    if (data.containsKey('simpleString') && data['simpleString'] is String) {
      simpleString = data['simpleString'] as String;
    } else {
      throw new ArgumentError.value(
          data, 'data', "No valid field for property 'simpleString'");
    }

    if (data.containsKey('stringWithSingleQuotes') &&
        data['stringWithSingleQuotes'] is String) {
      stringWithSingleQuotes = data['stringWithSingleQuotes'] as String;
    } else {
      throw new ArgumentError.value(
          data, 'data', "No valid field for property 'stringWithSingleQuotes'");
    }

    if (data.containsKey('singleLineStringMixedQuotes') &&
        data['singleLineStringMixedQuotes'] is String) {
      singleLineStringMixedQuotes =
          data['singleLineStringMixedQuotes'] as String;
    } else {
      throw new ArgumentError.value(data, 'data',
          "No valid field for property 'singleLineStringMixedQuotes'");
    }

    if (data.containsKey('stringLiteralSimple') &&
        data['stringLiteralSimple'] is String) {
      stringLiteralSimple = data['stringLiteralSimple'] as String;
    } else {
      throw new ArgumentError.value(
          data, 'data', "No valid field for property 'stringLiteralSimple'");
    }

    if (data.containsKey('stringLiteralWithTripleSingleQuote') &&
        data['stringLiteralWithTripleSingleQuote'] is String) {
      stringLiteralWithTripleSingleQuote =
          data['stringLiteralWithTripleSingleQuote'] as String;
    } else {
      throw new ArgumentError.value(data, 'data',
          "No valid field for property 'stringLiteralWithTripleSingleQuote'");
    }

    return new DfltStrings._from(
        data,
        simpleString,
        stringWithSingleQuotes,
        singleLineStringMixedQuotes,
        stringLiteralSimple,
        stringLiteralWithTripleSingleQuote);
  }
}

class DfltNamed extends OmnibusEvent {
  /// omnibusId
  static const id = 'omnibuild.v0.DfltNamed';

  final String namedString;

  final List<int> namedList;

  final Map<String, int> namedMap;

  final JsonDateTime namedObject;

  /// Constructor
  DfltNamed(
      {final String namedString: '',
      final List<int> namedList: const [],
      final Map<String, int> namedMap: const {},
      final JsonDateTime namedObject: null})
      : namedString = namedString,
        namedList = namedList,
        namedMap = namedMap,
        namedObject = namedObject,
        super(id, {
          'namedString': namedString,
          'namedList': namedList,
          'namedMap': namedMap,
          'namedObject': namedObject
        });

  /// Internal constructor for fromJson
  DfltNamed._from(final Map<String, dynamic> data, String namedString,
      List<int> namedList, Map<String, int> namedMap, JsonDateTime namedObject)
      : namedString = namedString,
        namedList = namedList,
        namedMap = namedMap,
        namedObject = namedObject,
        super(id, data);

  /// Data map input constructor
  factory DfltNamed.fromJson(final Map<String, dynamic> data) {
    String namedString;
    List<int> namedList;
    Map<String, int> namedMap;
    JsonDateTime namedObject;

    if (data.containsKey('namedString') && data['namedString'] is String) {
      namedString = data['namedString'] as String;
    } else {
      throw new ArgumentError.value(
          data, 'data', "No valid field for property 'namedString'");
    }

    if (data.containsKey('namedList') && data['namedList'] is List<int>) {
      namedList = data['namedList'] as List<int>;
    } else {
      throw new ArgumentError.value(
          data, 'data', "No valid field for property 'namedList'");
    }

    if (data.containsKey('namedMap') && data['namedMap'] is Map<String, int>) {
      namedMap = data['namedMap'] as Map<String, int>;
    } else {
      throw new ArgumentError.value(
          data, 'data', "No valid field for property 'namedMap'");
    }

    if (data.containsKey('namedObject') && data['namedObject'] is String) {
      namedObject = new JsonDateTime.fromJson(data['namedObject'] as String);
    } else {
      throw new ArgumentError.value(
          data, 'data', "No valid field for property 'namedObject'");
    }

    return new DfltNamed._from(
        data, namedString, namedList, namedMap, namedObject);
  }
}

class ExoticDefaults extends OmnibusEvent {
  /// omnibusId
  static const id = 'omnibuild.v0.ExoticDefaults';

  final List<int> defaultedList;

  final Map<String, int> defaultedMap;

  final Point defaultedConstructor;

  /// Constructor
  ExoticDefaults(
      [final List<int> defaultedList = const [0, 2, 4, 6, 8],
      final Map<String, int> defaultedMap = const {'a': 0, 'b': 1, 'c': 2},
      final Point defaultedConstructor = const Point(1, 2)])
      : defaultedList = defaultedList,
        defaultedMap = defaultedMap,
        defaultedConstructor = defaultedConstructor,
        super(id, {
          'defaultedList': defaultedList,
          'defaultedMap': defaultedMap,
          'defaultedConstructor': defaultedConstructor
        });

  /// Internal constructor for fromJson
  ExoticDefaults._from(final Map<String, dynamic> data, List<int> defaultedList,
      Map<String, int> defaultedMap, Point defaultedConstructor)
      : defaultedList = defaultedList,
        defaultedMap = defaultedMap,
        defaultedConstructor = defaultedConstructor,
        super(id, data);

  /// Data map input constructor
  factory ExoticDefaults.fromJson(final Map<String, dynamic> data) {
    List<int> defaultedList;
    Map<String, int> defaultedMap;
    Point defaultedConstructor;

    if (data.containsKey('defaultedList') &&
        data['defaultedList'] is List<int>) {
      defaultedList = data['defaultedList'] as List<int>;
    } else {
      throw new ArgumentError.value(
          data, 'data', "No valid field for property 'defaultedList'");
    }

    if (data.containsKey('defaultedMap') &&
        data['defaultedMap'] is Map<String, int>) {
      defaultedMap = data['defaultedMap'] as Map<String, int>;
    } else {
      throw new ArgumentError.value(
          data, 'data', "No valid field for property 'defaultedMap'");
    }

    if (data.containsKey('defaultedConstructor') &&
        data['defaultedConstructor'] is Map<String, int>) {
      defaultedConstructor =
          new Point.fromJson(data['defaultedConstructor'] as Map<String, int>);
    } else {
      throw new ArgumentError.value(
          data, 'data', "No valid field for property 'defaultedConstructor'");
    }

    return new ExoticDefaults._from(
        data, defaultedList, defaultedMap, defaultedConstructor);
  }
}
