// Copyright (c) 2016, Herman Bergwerf. All rights reserved.
// Use of this source code is governed by a MIT-style license
// that can be found in the LICENSE file.

/// This is actually a dummy library that allows the Dart analyzer to link
/// the right classes to the generated messages code in this directory.
library omnibuild.test.test_messages;

import 'package:omnibus/omnibus.dart';

part 'readme.v0.dart';
part 'pure_types.v0.dart';
part 'dflt_values.v0.dart';

/// Object with const constructor
class Point {
  /// Variables
  final int x, y;

  /// Constructor
  const Point(this.x, this.y);

  /// Reverse constructor
  factory Point.fromJson(Map<String, int> json) {
    return new Point(json['x'], json['y']);
  }

  /// JSON converter
  Map<String, int> toJson() {
    return {'x': x, 'y': y};
  }
}

/// DataTime extended with fromJson
class JsonDateTime extends DateTime {
  factory JsonDateTime.fromJson(String json) {
    return DateTime.parse(json);
  }
}

/// Enumeration that is used in the README.md example
enum ImpactFactor { low, medium, high }
